"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const Draggable_1 = tslib_1.__importDefault(require("./Draggable"));
function DraggableContainer({ onOrderChange, children }) {
    const [els, setEls] = react_1.default.useState([]);
    const [currentIdx, setCurrentIdx] = react_1.default.useState(null);
    const [toIdx, setToIdx] = react_1.default.useState(null);
    const onDragStart = (idx) => {
        setCurrentIdx(idx);
    };
    const onDragEnter = (idx) => {
        setToIdx(idx);
    };
    const dragDrop = () => {
        const _els = [...els];
        let currentEl = null;
        if (currentIdx !== toIdx) {
            currentEl = Object.assign({}, _els[currentIdx]);
            _els.splice(toIdx, 0, currentEl);
            setCurrentIdx(null);
            setToIdx(null);
            setEls(_els);
        }
        if (currentEl && onOrderChange) {
            onOrderChange(_els.indexOf(currentEl), toIdx);
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.Children.map(children, (child, idx) => {
        return (react_1.default.createElement(Draggable_1.default, { key: idx, onDragStart: () => onDragStart(idx), onDragEnter: () => onDragEnter(idx), onDragEnd: dragDrop }, child));
    })));
}
exports.default = DraggableContainer;
//# sourceMappingURL=DraggableContainer.js.map