import React from 'react';
import Draggable from './Draggable';
export default function DraggableContainer({ onOrderChange, children }) {
    const [els, setEls] = React.useState([]);
    const [currentIdx, setCurrentIdx] = React.useState(null);
    const [toIdx, setToIdx] = React.useState(null);
    const onDragStart = (idx) => {
        setCurrentIdx(idx);
    };
    const onDragEnter = (idx) => {
        setToIdx(idx);
    };
    const dragDrop = () => {
        const _els = [...els];
        let currentEl = null;
        if (currentIdx !== toIdx) {
            currentEl = Object.assign({}, _els[currentIdx]);
            _els.splice(toIdx, 0, currentEl);
            setCurrentIdx(null);
            setToIdx(null);
            setEls(_els);
        }
        if (currentEl && onOrderChange) {
            onOrderChange(_els.indexOf(currentEl), toIdx);
        }
    };
    return (React.createElement(React.Fragment, null, React.Children.map(children, (child, idx) => {
        return (React.createElement(Draggable, { key: idx, onDragStart: () => onDragStart(idx), onDragEnter: () => onDragEnter(idx), onDragEnd: dragDrop }, child));
    })));
}
//# sourceMappingURL=DraggableContainer.js.map